#include "stdafx.h"
#include "MtlWin.h"

namespace MTL {

// Fatal bug fixed by JOBBY, thanks!
int MtlGetLBTextFixed(HWND hWndCombo, int nIndex, CString& strText)
{
	CComboBox combo(hWndCombo);
	ATLASSERT(combo.IsWindow());
	int nRet = combo.GetLBText(nIndex, strText.GetBufferSetLength( combo.GetLBTextLen(nIndex)*2 ));
	strText.ReleaseBuffer();
	return nRet;
}

int MtlListBoxGetText(HWND hWndBox, int nIndex, CString& strText)
{
	CListBox box(hWndBox);
	ATLASSERT(box.IsWindow());
	int nRet = box.GetText(nIndex, strText.GetBufferSetLength( box.GetTextLen(nIndex)*2 ));
	strText.ReleaseBuffer();
	return nRet;
}

// UDT DGSTR ( add , delete TrayIcon
BOOL TrayMessage(HWND hwnd, DWORD dwMessage, UINT uID, int id, PSTR pszTip)
{
	BOOL           res;
	HICON          hIcon;
	NOTIFYICONDATA tnd;
	HINSTANCE hInst = _Module.GetResourceInstance();
	hIcon=LoadIcon( hInst, MAKEINTRESOURCE(id));

	tnd.cbSize      = sizeof(NOTIFYICONDATA);
	tnd.hWnd        = hwnd;
	tnd.uID         = uID;
	tnd.uFlags      = NIF_MESSAGE | NIF_ICON | NIF_TIP;
	tnd.uCallbackMessage    = MYWM_NOTIFYICON;
	tnd.hIcon       = hIcon;
	if (pszTip) lstrcpyn(tnd.szTip, pszTip, sizeof(tnd.szTip));
	else        tnd.szTip[0] = '\0';

	res = Shell_NotifyIcon(dwMessage, &tnd);
	if (hIcon)      DestroyIcon(hIcon);

	return res;
}
// ENDE

// MDI client window wrapper class
/*class CMDIClientWindow : public WTL::CMDIWindow
{
public:
	CMDIClientWindow(HWND hWnd)
	{
		m_hWndMDIClient = hWnd;
	}
};*/

//
//CLockRedraw̒`
//
CLockRedraw::CLockRedraw(HWND hWnd)
	: m_wnd(hWnd)
{
	if (m_wnd.m_hWnd) {
		m_wnd.SetRedraw(FALSE);
	}
}

CLockRedraw::~CLockRedraw()
{
	if (m_wnd.m_hWnd) {
		m_wnd.SetRedraw(TRUE);
		m_wnd.Invalidate();
		m_wnd.UpdateWindow();
	}
}

//
//CLockRedrawMDIClient̒`
//
CLockRedrawMDIClient::CLockRedrawMDIClient(HWND hWnd)
	: m_wndMDIClient(hWnd)
{
	m_wndMDIClient.ShowWindow(SW_HIDE);
}

CLockRedrawMDIClient::~CLockRedrawMDIClient()
{
	m_wndMDIClient.ShowWindow(SW_SHOW);
}

bool MtlIsFamily(HWND hWnd1, HWND hWnd2)
{
	if (hWnd1 == NULL || hWnd2 == NULL)
		return false;

	if (hWnd1 == hWnd2)
		return true;

	CWindow wnd1(hWnd1);
	CWindow wnd2(hWnd2);

	return wnd1.GetTopLevelParent() == wnd2.GetTopLevelParent();
}

void MtlSetForegroundWindow(HWND hWnd)
{
	::SetForegroundWindow(hWnd);
	::SetWindowPos(hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSENDCHANGING|SWP_NOSIZE);
	::SetWindowPos(hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSENDCHANGING|SWP_NOSIZE);
}

bool MtlIsApplicationActive(HWND hWnd)
{
	ATLASSERT(::IsWindow(hWnd));

	CWindow wndFrame = CWindow(hWnd).GetTopLevelParent();
	CVersional<WINDOWPLACEMENT> wndpl; wndFrame.GetWindowPlacement(&wndpl);
	if (wndpl.showCmd == SW_SHOWMINIMIZED)
		return false;

	CWindow wndFore = ::GetForegroundWindow();
	if (wndFore.m_hWnd == NULL)
		return false;

	CWindow wndForeParent = wndFore.GetTopLevelParent();
	return wndFrame.m_hWnd == wndForeParent.m_hWnd;
}


//
//CCriticalIdleTimer̒`
//
void CCriticalIdleTimer::InstallCriticalIdleTimer(HWND hWndMainFrame, WORD wCmdID)
{
	s_hWndMainFrame = hWndMainFrame;
	s_wCmdID = wCmdID;

	if (s_nTimerID == 0)
		s_nTimerID = ::SetTimer(NULL, 0, 800, FocusCheckerTimerProc);
}

void CCriticalIdleTimer::UninstallCriticalIdleTimer()
{
	if (s_nTimerID != 0) {
		::KillTimer(NULL, s_nTimerID);
		s_nTimerID = 0;
	}
}

VOID CALLBACK CCriticalIdleTimer::FocusCheckerTimerProc(HWND hwnd, UINT uMsg, UINT_PTR idEvent, DWORD dwTime)
{
	FocusChecker();
}

void CCriticalIdleTimer::FocusChecker()
{
	MtlSendCommand(s_hWndMainFrame, s_wCmdID);
}


UINT_PTR CCriticalIdleTimer::s_nTimerID = 0;
HWND CCriticalIdleTimer::s_hWndMainFrame = NULL;
WORD CCriticalIdleTimer::s_wCmdID = 0;






////////////////////////////////////////////////////////////////////////////
} // namespace MTL;

