#pragma once

//vOC̃f[^^E萔̒`
#include "./include/PluginInfo.h"



#define ENTRY_PLUGINPROC(func,type) \
	static type GetPtr_##func(HINSTANCE hInst) \
	{ \
		if(!hInst) return NULL; \
		return (type)::GetProcAddress(hInst,_T(#func)); \
	}



class CPluginManager
{
public:
	typedef int (WINAPI *LPFPLUGINEVENT)(UINT, FPARAM, SPARAM);
	typedef void (WINAPI *LPFGETPLUGININFO)(PLUGININFO*);
	typedef HWND (WINAPI *LPFCREATEPLUGINWINDOW)(HWND);
	typedef HWND (WINAPI *LPFCREATEEXPLORERPANE)(HWND, UINT);
	typedef HWND (WINAPI *LPFCREATETOOLBAR)(HWND, UINT);
	typedef void (WINAPI *LPFSHOWEXPLORERMENU)(int, int);
	typedef BOOL (WINAPI *LPFPRETRANSLATEMESSAGE)(MSG*);
	typedef void (WINAPI *LPFPLUGINSETTING)();
	typedef void (WINAPI *LPFSHOWTOOLBARMENU)(UINT);

	typedef BOOL (WINAPI *LPFEVENT_TABCHANGED)(int, IWebBrowser*); //obsolete

	//p̃vOCf[^\
	struct PluginData {
		HINSTANCE hInstDLL;
		HWND hWnd;
		CString strCaption;
		CString strIniKey;
		LPFPLUGINEVENT fpEvent;
		int nStyle;

		PluginData()
		{
			hInstDLL = NULL;
			hWnd = NULL;
			fpEvent = NULL;
			nStyle = PLUGIN_STYLE_DERAYLOADING;
		}
	};

private:
	//oϐ
	typedef std::vector<PluginData> PluginArray;
	static PluginArray* m_avecData;	//vOC^Cṽf[^̔z(vector)

#ifdef _DEBUG
	static int m_nLoadCount;
	static int m_nCreateCount;
#endif //_DEBUG

	//vOC֐̃|C^擾֐ɓWJ}N
	//GetPtr_֐DLL̃CX^XnhɂČĂяo
	//ex. LPFGETPLUGININFO pfGetPInfo = GetPtr_GetPluginInfo(hInstDLL);
	ENTRY_PLUGINPROC(GetPluginInfo,LPFGETPLUGININFO)
	ENTRY_PLUGINPROC(PluginEvent,LPFPLUGINEVENT)
	ENTRY_PLUGINPROC(CreatePluginWindow,LPFCREATEPLUGINWINDOW)
	ENTRY_PLUGINPROC(CreateExplorerPane,LPFCREATEEXPLORERPANE)
	ENTRY_PLUGINPROC(CreateToolBar,LPFCREATETOOLBAR)
	ENTRY_PLUGINPROC(ShowExplorerMenu,LPFSHOWEXPLORERMENU)
	ENTRY_PLUGINPROC(PreTranslateMessage,LPFPRETRANSLATEMESSAGE)
	ENTRY_PLUGINPROC(PluginSetting,LPFPLUGINSETTING)
	ENTRY_PLUGINPROC(Event_TabChanged,LPFEVENT_TABCHANGED)
	ENTRY_PLUGINPROC(ShowToolBarMenu,LPFSHOWTOOLBARMENU)

	//vOC\̂̃|C^擾
	static PluginData* GetDataPtr(int nKind, int nIndex);

	//[hɎsvOCЕt
	static void SettleBadPlugin(int nKind, int nIndex, PluginData& data, HWND hWnd = NULL);

	static BOOL ReleasePluginData(PluginData& data);

	//vOCz񂩂폜iEBhE̊Jsj
	static BOOL RemovePlugin(int nKind, int nIndex);

	static void ErrMsg_FailLoad(LPCTSTR lpstrName, LPCTSTR lpstrPath, HWND hWnd = NULL);

public:
	CPluginManager();
	~CPluginManager();
	static void Init();
	static void Term();

	//vOC̃^Cg擾
	//BOOL^̗̈ւ̃|C^w肳ΐEsɕԂ
	static CString GetCaption(int nKind, int nIndex, BOOL *pbRet = NULL);

	//vOC̃EBhEnh擾
	//sƂA͍쐬ĂȂꍇNULLԂ
	static HWND GetHWND(int nKind, int nIndex);

	bool IsEarlyLoading(int nKind, int nIndex);

	static int GetCount(int nKind);

	//DLL̃[hyуvOC̓ǂݍ݂s
	static BOOL ReadPluginData(int nKind, HWND hWnd = NULL);

	//vOC̃[hs
	//̓vOC̎ނƔԍƁAgݍސeEBhẼnh
	static BOOL LoadPlugin(int nKind, int nIndex, HWND hWndParent, bool Force = true);

	static BOOL LoadAllPlugin(int nKind, HWND hWndParent, bool bForce = false);

	static void DeleteAllPlugin(int nKind = -1);

	//vOC̊֐Ăяo[`
	static void Call_ShowExplorerMenu(int nIndex, int x, int y);
	static int Call_PluginEvent(int nKind, int nIndex, UINT uMsg ,FPARAM fParam, SPARAM sParam);
	static BOOL Call_PreTranslateMessage(int nKind, int nIndex, MSG* lpMsg);
	static void Call_PluginSetting(int nKind, int nIndex);
	static BOOL Call_Event_TabChanged(int nKind, int nIndex, int nNewTabIndex, IWebBrowser* pWB);
	static void Call_ShowToolBarMenu(int nKind, int nIndex, UINT uID);

	//SẴvOCɑ΂ăCxg𑗂
	static void BroadCast_PluginEvent(UINT uMsg, FPARAM fParam, SPARAM sParam);
	
	//SẴvOCɑ΂ăCxgɑA0̒lԂꂽ_ŏI
	static int ChainCast_PluginEvent(UINT uMsg, FPARAM fParam, SPARAM sParam);

};
