/*
	c[r[`ŃIvVǗ邽߂̃_CAO
	\[Xev[gɈˑ邽ߔėp͔ɒႭȂĂ܂B
 */

#ifndef __PROPERTY_SHEET_H_
#define __PROPERTY_SHEET_H_


class CTreeViewPropertySheet : public CDialogImpl<CTreeViewPropertySheet>
{
public:
	enum { IDD = IDD_PROPSHEET,
           TITLELENGTH = 200, SPACE = 2};

	struct PAGEINFO{
		PROPSHEETPAGE psp;
		char title[TITLELENGTH];
		HWND hWnd;
		int nIndent;
	};

	CSimpleArray<PAGEINFO*> m_aryPage;
	int m_nWidth, m_nHeight;
	CString m_Title;
	HWND m_hActiveWnd;
	CTreeViewCtrl m_TreeView;
	static HHOOK	s_hHook;
	static CTreeViewPropertySheet* s_pThis;
	int m_nCurSel;
	bool m_bInitPos;

	CTreeViewPropertySheet(LPCTSTR title = NULL)
	{
		m_Title = title;
		m_nCurSel = 0;
		m_bInitPos = false;
	}
	
	BOOL AddPage(PROPSHEETPAGE* pPage, int nIndent = -1)
	{
		ATLASSERT(pPage != NULL);

		PAGEINFO *ppi = new PAGEINFO;
		ppi->psp = *pPage;
		ppi->hWnd = NULL;
		ppi->nIndent = nIndent;
		m_aryPage.Add(ppi);
		return TRUE;
	}

	int DoModal(HWND hWndParent = ::GetActiveWindow(), LPARAM dwInitParam = NULL)
	{
		if(m_aryPage.GetSize() == 0) return 0;
		
		//L[ANZ[^pɃtbN
		s_pThis = this;
		s_hHook = ::SetWindowsHookEx(WH_MSGFILTER,MsgFilterProc,_Module.GetResourceInstance(), ::GetCurrentThreadId()); 

		return CDialogImpl<CTreeViewPropertySheet>::DoModal(hWndParent,dwInitParam);
	}

	static LRESULT CALLBACK MsgFilterProc(int code, WPARAM wParam, LPARAM lParam)
	{
		if(code >= 0){
			MSG* pMsg = (MSG*)lParam;
			if((WM_KEYFIRST <= pMsg->message && pMsg->message <= WM_KEYLAST) ||
			   (WM_MOUSEFIRST <= pMsg->message && pMsg->message <= WM_MOUSELAST))
			{

				HWND hWnd = s_pThis->_GetActivePage();

				if(pMsg->message == WM_KEYDOWN && pMsg->wParam == VK_TAB){
					HWND hWndFocus = ::GetFocus();
					HWND hWndDlg = s_pThis->m_hActiveWnd;
					BOOL bPrevious = ::GetAsyncKeyState(VK_SHIFT) & 0x80000000;

					HWND hWndNext = ::GetNextDlgTabItem(hWndDlg, hWndFocus, bPrevious);
					if(!hWndNext){
						hWndNext = ::GetNextDlgTabItem(hWndDlg, NULL, bPrevious); 
					}
					::SetFocus(hWndNext);
					return 1;
				}
				
				PSHNOTIFY pn;
				pn.hdr.code  = PSN_TRANSLATEACCELERATOR;
				pn.hdr.hwndFrom = s_pThis->m_hWnd;
				pn.hdr.idFrom = 0;
				pn.lParam = lParam;
				int nRet =  ::SendMessage(hWnd,WM_NOTIFY,(WPARAM)0,(LPARAM)&pn);
				if(nRet == 0) 
					return ::CallNextHookEx(s_hHook,code,wParam,lParam);
				else 
					return nRet;
			}
		}
		return ::CallNextHookEx(s_hHook,code,wParam,lParam);
	}

	BEGIN_MSG_MAP(CTreeViewPropertySheet)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	MESSAGE_HANDLER(WM_DESTROY,OnDestroy)
	MESSAGE_HANDLER(WM_SIZE,OnSize)
	COMMAND_ID_HANDLER(IDOK, OnOk)
	COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
	COMMAND_ID_HANDLER(IDC_APPLY, OnApply)
	//NOTIFY_HANDLER(IDC_TREEVIEW,TVN_SELCHANGED,OnSelChanged)
	NOTIFY_HANDLER(IDC_TREEVIEW,TVN_SELCHANGING,OnSelChanging)
	END_MSG_MAP()

	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		//ACRǂݍ
		HICON hIcon = (HICON)::LoadImage(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_MAINFRAME), 
			IMAGE_ICON, ::GetSystemMetrics(SM_CXICON), ::GetSystemMetrics(SM_CYICON), LR_DEFAULTCOLOR);
		SetIcon(hIcon, TRUE);

		//_CAOev[g
		_ReadyDialogResources();

		//c[r[
		_InitTreeView();

		//ŏ̃y[W\
		m_hActiveWnd = _LoadDialog(0);
		_BeChild(m_hActiveWnd,m_hWnd);
		::ShowWindow(m_hActiveWnd,SW_SHOW);
		NotifyToDialog(m_hActiveWnd,PSN_SETACTIVE);
		m_TreeView.Select(m_TreeView.GetFirstVisibleItem(),TVGN_CARET);

		
		MoveWindow(0,0,m_nWidth + 180, m_nHeight + 70, TRUE);
		_SetTitle(0);

		return 0;
	}

	LRESULT OnDestroy(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		::UnhookWindowsHookEx(s_hHook); //tbN
		_ReleasePages();
		return 0;
	}
	
	LRESULT OnSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		/*
		int style = GetWindowLong(GWL_STYLE);
		if(style & WS_THICKFRAME){
			//style &= ~WS_THICKFRAME;
			style |= WS_OVERLAPPED | WS_CAPTION;// | //DS_MODALFRAME;// | WS_EX_DLGMODALFRAME; //tYC 
			SetWindowLong(GWL_STYLE,style);
			CenterWindow(GetParent());
		}*/

		if(!m_bInitPos){
			CenterWindow(GetParent());
			m_bInitPos = true;
		}

		CRect rc,rcb;
		GetClientRect(&rc);
		
		rc.right -= SPACE;
		rc.left = rc.right - m_nWidth;
		rc.top = SPACE * 5;
		rc.bottom = m_nHeight + rc.top;
		CWindow(m_hActiveWnd).MoveWindow(&rc , TRUE);

		rc.right = rc.left - SPACE;
		rc.left = SPACE * 4;
		rc.bottom += 20;
		m_TreeView.MoveWindow(&rc,TRUE);

		GetClientRect(&rc);
		CWindow(GetDlgItem(IDC_APPLY)).GetClientRect(&rcb);
		rc.right -= SPACE * 10;
		rc.left = rc.right - rcb.Width();
		rc.bottom -= SPACE * 3;
		rc.top = rc.bottom - rcb.Height();
		CWindow(GetDlgItem(IDC_APPLY)).MoveWindow(&rc);
		rc.right = rc.left - SPACE * 3;
		rc.left -= rcb.Width();
		CWindow(GetDlgItem(IDCANCEL)).MoveWindow(&rc);
		rc.right = rc.left - SPACE * 3;
		rc.left -= rcb.Width();
		CWindow(GetDlgItem(IDOK)).MoveWindow(&rc);

		return S_OK;
	}

	LRESULT OnOk(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		if(!_ApplyToDialogs())
			return 0;
		EndDialog(wID);
		return 0;
	}

	LRESULT OnCancel(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		EndDialog(wID);
		return 0;
	}

	LRESULT OnApply(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		_ApplyToDialogs();
		return 0;
	}

	BOOL _ApplyToDialogs()
	{
		int count = m_aryPage.GetSize();
		PAGEINFO* ppi = m_aryPage[m_nCurSel];

		//܂Jg^uɕύXʒmDDXȂǂɈȂmF
		//Jg^uȊODDX_INT_RANGEȂǂɈ邱Ƃ͂Ȃ̂ł܂Ƃ߂forŏ
		if(::IsWindow(ppi->hWnd))
			if(NotifyToDialog(ppi->hWnd,PSN_APPLY) != FALSE)
				return FALSE;

		for(int i=0; i<count; i++){
			if( m_nCurSel == i) continue;

			PAGEINFO* ppi = m_aryPage[i];
			if(::IsWindow(ppi->hWnd))
				if(NotifyToDialog(ppi->hWnd,PSN_APPLY) != FALSE)
					return FALSE;
		}

		return TRUE;
	}


	LRESULT OnSelChanging(int idCtrl, LPNMHDR pnmh, BOOL& bHandled)
	{
		NMTREEVIEW* ptv = (NMTREEVIEW*)pnmh;
		int newindex = (int)ptv->itemNew.lParam;
		int oldindex = (int)ptv->itemOld.lParam;

		if(newindex == oldindex) return 0;
		HWND hOldWnd = m_aryPage[oldindex]->hWnd;
		HWND hNewWnd = m_aryPage[newindex]->hWnd;
		if(::IsWindow(hOldWnd)){
			//Â͉̂B
			BOOL bRet = NotifyToDialog(hOldWnd,PSN_KILLACTIVE);
			if(bRet != FALSE) {
				return 1; //LZꂽ
			}
			::ShowWindow(hOldWnd,SW_HIDE);
		}
		if(hNewWnd == NULL){
			//V͕̂KvȂ쐬
			m_aryPage[newindex]->hWnd = _LoadDialog(newindex);
			_BeChild(m_aryPage[newindex]->hWnd,m_hWnd);
		}
		m_hActiveWnd = m_aryPage[newindex]->hWnd;
		_MoveChild(m_hActiveWnd);
		::ShowWindow(m_hActiveWnd,SW_SHOW);
		
		NotifyToDialog(m_hActiveWnd,PSN_SETACTIVE);
		_SetTitle(newindex);

		::SetFocus(m_hActiveWnd);
		m_nCurSel = newindex;
		return 0;
	}


	void _ReadyDialogResources()
	{
		int max_w,max_h;
		int count = m_aryPage.GetSize();

		max_w = max_h = 0;
		for(int i=0; i<count; i++){
			PAGEINFO* ppi = m_aryPage[i];

			HRSRC hRes =  ::FindResource(_Module.GetResourceInstance(),ppi->psp.pszTemplate,RT_DIALOG);
			if(hRes){
				HGLOBAL hMem = ::LoadResource(_Module.GetResourceInstance(),hRes);
				if(hMem){
					LPBYTE pMem = (LPBYTE)::LockResource(hMem);
					if(pMem){
						
						//_CAÕTCY擾
						WCHAR* wpstr = (WCHAR*)pMem; 
						if((*wpstr == 1) && (*(wpstr+1) == 0xFFFF)){
							//gev[g
							DLGTEMPLATEEX_HALF *dpe = (DLGTEMPLATEEX_HALF*)pMem;
							if(max_w < dpe->cx) max_w = dpe->cx;
							if(max_h < dpe->cy) max_h = dpe->cy;
							wpstr += 13;
						}else{
							//ʂ̃ev[g
							DLGTEMPLATE *dp = (DLGTEMPLATE *)pMem;
							if(max_w < dp->cx) max_w = dp->cx;
							if(max_h < dp->cy) max_h = dp->cy;
							char* pstr = (char*)(pMem + sizeof(DLGTEMPLATE));
							wpstr = (WCHAR*)pstr;
						}
						
						for(int j=0; j<2; j++){	//j[NXȂǂ̏ǂݔ΂
							if(*wpstr == 0) wpstr++;
							else if(*wpstr == 0xFFFF) wpstr+=2;
							else _SeekUnicode(&wpstr);
						}

						//LvV擾
						::WideCharToMultiByte(CP_ACP,0,wpstr,-1,ppi->title,TITLELENGTH,NULL,NULL);
					}
				}
			}
		}
		//_CAOPʂsNZPʂɕϊ
		CRect rc(0,0,max_w,max_h);
		MapDialogRect(&rc);
		m_nWidth = rc.Width();
		m_nHeight = rc.Height();
		//m_nWidth = max_w * LOWORD(GetDialogBaseUnits()) / 4.0;
		//m_nHeight = max_h * HIWORD(GetDialogBaseUnits()) / 8.0;
	}

	void _SeekUnicode(WCHAR** wppstr)
	{
		WCHAR* wpstr = *wppstr;
		while(*wpstr != 0)
			wpstr++;
		*wppstr = ++wpstr;
	}
	
	void _InitTreeView()
	{
		m_TreeView = GetDlgItem(IDC_TREEVIEW);
		
		//o^
		HTREEITEM hParent = TVI_ROOT;
		HTREEITEM hItem = TVI_ROOT;
		int count = m_aryPage.GetSize();
		for(int i=0; i<count; i++){
			PAGEINFO* ppi = m_aryPage[i];
			m_TreeView.Expand(hParent,TVE_EXPAND);
			if(ppi->nIndent == -1){
				hItem = m_TreeView.InsertItem(ppi->title,TVI_ROOT,TVI_LAST);
				hParent = TVI_ROOT;
			}else if(ppi->nIndent == 0){
				hItem = m_TreeView.InsertItem(ppi->title,hParent,TVI_LAST);
			}else{
				hParent = hItem;
				hItem = m_TreeView.InsertItem(ppi->title,hItem,TVI_LAST);
			}
			m_TreeView.SetItemData(hItem,i);
			
		}

		//ݒ
		m_TreeView.SetItemHeight(16);
		int style = m_TreeView.GetWindowLong(GWL_STYLE);
		style &= ~(WS_HSCROLL | WS_TABSTOP);
		m_TreeView.SetWindowLong(GWL_STYLE,style);
	}

	void _ReleasePages()
	{
		ShowWindow(SW_HIDE);
		
		int count = m_aryPage.GetSize();
		for(int i=0; i<count; i++){
			PAGEINFO* ppi = m_aryPage[i];

			if(::IsWindow(ppi->hWnd)) 
				::DestroyWindow(ppi->hWnd);
			delete ppi;
		}
		m_aryPage.RemoveAll();
	}

	void _BeChild(HWND hWnd, HWND hParent)
	{
		CWindow Wnd = hWnd;
		int style = Wnd.GetWindowLong(GWL_STYLE);
		style |= WS_CHILD | WS_GROUP | WS_TABSTOP;
		style &= ~(WS_POPUP | WS_CAPTION | WS_DISABLED | WS_MINIMIZEBOX | WS_MAXIMIZEBOX);
		Wnd.SetWindowLong(GWL_STYLE,style);
		Wnd.SetParent(hParent);
	}

	HWND _LoadDialog(int nIndex)
	{
		PAGEINFO* ppi = m_aryPage[nIndex];
		ATLASSERT(ppi->hWnd == NULL);

		//R[obN𑗂
		ppi->psp.pfnCallback(NULL,PSPCB_CREATE,&(ppi->psp)); 

		//_CAO쐬
		ppi->hWnd = ::CreateDialog(_Module.GetModuleInstance(),ppi->psp.pszTemplate,
			                  GetParent(), ppi->psp.pfnDlgProc);

		return ppi->hWnd;
	}

	void _SetTitle(int index)
	{
		PAGEINFO* ppi = m_aryPage[index];
		CString strTitle;
		strTitle.Format(_T("%s - %s"),m_Title,ppi->title);
		SetWindowText(strTitle);
	}

	BOOL NotifyToDialog(HWND hWnd,int code){
		//_CAOɊeʒmbZ[W𑗂
		NMHDR nmh;
		nmh.code = code;
		nmh.hwndFrom = m_hWnd;
		nmh.idFrom = 0;
		ATLASSERT(hWnd != NULL);
		return (BOOL)::SendMessage(hWnd,WM_NOTIFY,0,(LPARAM)&nmh);
	}

	void _MoveChild(HWND hWnd)
	{
		CWindow Wnd = hWnd;
		CRect rc;

		GetClientRect(&rc);
		rc.right -= SPACE;
		rc.left = rc.right - m_nWidth;
		rc.top = SPACE;
		rc.bottom = m_nHeight + rc.top;
		Wnd.MoveWindow(&rc,TRUE);
	}

	typedef struct DLGTEMPLATEEX_HALF{  
		WORD   dlgVer; 
		WORD   signature; 
		DWORD  helpID; 
		DWORD  exStyle; 
		DWORD  style; 
		WORD   cDlgItems; 
		short  x; 
		short  y; 
		short  cx; 
		short  cy; 
	}; //DLGTEMPLATEEX̑O

	HWND _GetActivePage()
	{
		HTREEITEM hItem = m_TreeView.GetSelectedItem();
		ATLASSERT(hItem != NULL);

		int nIndex = m_TreeView.GetItemData(hItem);
		PAGEINFO* ppi = m_aryPage[nIndex];
		return ppi->hWnd;
	}
};

__declspec(selectany) HHOOK CTreeViewPropertySheet::s_hHook = NULL;
__declspec(selectany) CTreeViewPropertySheet* CTreeViewPropertySheet::s_pThis = NULL;


#endif //__PROPERTY_SHEET_H_